%define with_gui 0
Name: ecryptfs-utils
Version: 56
Release: 8%{?dist}
Summary: The eCryptfs mount helper and support libraries
Group: System Environment/Base
License: GPLv2+
URL: http://ecryptfs.sourceforge.net
Source0: http://downloads.sourceforge.net/ecryptfs/ecryptfs-utils-%{version}.tar.bz2
Patch0: ecryptfs-utils-verbosity-441822.patch
Patch1: ecryptfs-utils-mount-helper-gui.patch
Patch2: ecryptfs-utils-56-ssloptname.patch
Patch3: ecryptfs-utils-56-manpage.patch
Patch4: ecryptfs-utils-56-467234.patch

#required for ecryptfs-utils <=67
Patch5: ecryptfs-utils-56-473272.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: libgcrypt-devel keyutils-libs-devel openssl-devel pam-devel
BuildRequires: desktop-file-utils

%description
eCryptfs is a stacked cryptographic filesystem that ships in the
Linux kernel. This package provides the mount helper and supporting
libraries to perform key management and mount functions.

Install ecryptfs-utils if you would like to mount eCryptfs.

%if "%{with_gui}" == "1"
%package gui
Summary: The eCryptfs userspace graphical mount helper tool
Group: System Environment/Base 
Requires: %{name} = %{version}-%{release}
Requires: pygtk2 >= 2.6, usermode 

%description gui
A pygtk-based graphical mount helper tool for eCryptfs overlay mounts
%endif

%package devel
Summary: The eCryptfs userspace development package
Group: System Environment/Base
Requires: keyutils-libs-devel %{name} = %{version}-%{release}
Requires: pkgconfig

%description devel
Userspace development files for eCryptfs.

%prep
%setup -q
%patch0 -p1 -b .kh1
%if "%{with_gui}" == "1"
%patch1 -p1 -b .gui
%endif
%patch2 -p1 -b .kh2
%patch3 -p1 -b .kh3
%patch4 -p1 -b .467234
%patch5 -p1 -b .473272

%build
%configure --disable-opencryptoki --disable-rpath --disable-static
make %{?_smp_mflags} CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
rm -rf $RPM_BUILD_ROOT%{_libdir}/*.a
rm -rf $RPM_BUILD_ROOT%{_libdir}/*.la
rm -rf $RPM_BUILD_ROOT%{_defaultdocdir}/*

# gui bits (really needs Makefile integration...)                                                                                                                                                                                             
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}

%if "%{with_gui}" == "1"
  mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/security/console.apps/
  mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/
  install -p -m644 src/utils/ecryptfs-mount-helper-gui.glade $RPM_BUILD_ROOT%{_datadir}/%{name}/
  install -p -m755 src/utils/ecryptfs-mount-helper-gui.py $RPM_BUILD_ROOT%{_datadir}/%{name}/
  install -p -m644 src/utils/ecryptfs-mount-helper-gui.console $RPM_BUILD_ROOT%{_sysconfdir}/security/console.apps/ecryptfs-mount-helper-gui
  ln -s consolehelper $RPM_BUILD_ROOT%{_bindir}/ecryptfs-mount-helper-gui
  desktop-file-install --vendor system --delete-original      \
    --dir $RPM_BUILD_ROOT%{_datadir}/applications             \
    --add-category X-StartCom-Base                             \
    src/utils/ecryptfs-mount-helper-gui.desktop
  install -p -m644 src/utils/ecryptfs-mount-helper-gui.pam $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/ecryptfs-mount-helper-gui
%endif

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%if "%{with_gui}" == "1"
%post gui
touch --no-create %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  gtk-update-icon-cache -q %{_datadir}/icons/hicolor
fi

%postun gui
touch --no-create %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  gtk-update-icon-cache -q %{_datadir}/icons/hicolor
fi
%endif


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc README COPYING AUTHORS NEWS THANKS
%doc doc/ecryptfs-faq.html doc/ecryptfs-pam-doc.txt
/sbin/mount.ecryptfs
/sbin/mount.ecryptfs_private
/sbin/umount.ecryptfs_private
%{_bindir}/ecryptfs-add-passphrase
%{_bindir}/ecryptfs-insert-wrapped-passphrase-into-keyring
%{_bindir}/ecryptfs-manager
%{_bindir}/ecryptfs-mount-private
%{_bindir}/ecryptfs-rewrap-passphrase
%{_bindir}/ecryptfs-setup-private
%{_bindir}/ecryptfs-stat
%{_bindir}/ecryptfs-umount-private
%{_bindir}/ecryptfs-unwrap-passphrase
%{_bindir}/ecryptfs-wrap-passphrase
%{_bindir}/ecryptfs-zombie-kill
%{_bindir}/ecryptfs-zombie-list
%{_bindir}/ecryptfsd
%{_libdir}/libecryptfs.so.0.0.0
%{_libdir}/libecryptfs.so.0
%{_libdir}/ecryptfs
/%{_lib}/security/pam_ecryptfs.so
%{_mandir}/man1/ecryptfs-add-passphrase.1.gz
%{_mandir}/man1/ecryptfs-generate-tpm-key.1.gz
%{_mandir}/man1/ecryptfs-insert-wrapped-passphrase-into-keyring.1.gz
%{_mandir}/man1/ecryptfs-mount-private.1.gz
%{_mandir}/man1/ecryptfs-rewrap-passphrase.1.gz
%{_mandir}/man1/ecryptfs-setup-private.1.gz
%{_mandir}/man1/ecryptfs-umount-private.1.gz
%{_mandir}/man1/ecryptfs-unwrap-passphrase.1.gz
%{_mandir}/man1/ecryptfs-wrap-passphrase.1.gz
%{_mandir}/man1/ecryptfs-zombie-kill.1.gz
%{_mandir}/man1/ecryptfs-zombie-list.1.gz
%{_mandir}/man1/mount.ecryptfs_private.1.gz
%{_mandir}/man1/umount.ecryptfs_private.1.gz
%{_mandir}/man7/ecryptfs.7.gz
%{_mandir}/man8/ecryptfs-manager.8.gz
%{_mandir}/man8/ecryptfsd.8.gz
%{_mandir}/man8/mount.ecryptfs.8.gz
%{_mandir}/man8/pam_ecryptfs.8.gz

%if "%{with_gui}" == "1"
%files gui
%defattr(-,root,root,-)
%exclude %{_datadir}/%{name}/*.pyc
%exclude %{_datadir}/%{name}/*.pyo
%{_datadir}/%{name}/*.glade
%{_datadir}/%{name}/*.py
%{_bindir}/ecryptfs-mount-helper-gui
%{_datadir}/applications/*.desktop
%config(noreplace) %{_sysconfdir}/security/console.apps/ecryptfs-mount-helper-gui
%config(noreplace) %{_sysconfdir}/pam.d/ecryptfs-mount-helper-gui
%endif

%files devel
%defattr(-,root,root,-)
%{_libdir}/libecryptfs.so
%{_libdir}/pkgconfig/libecryptfs.pc
%{_includedir}/ecryptfs.h

%changelog
* Sun Jan 25 2009 Eddy Nigg <eddy_nigg.org>
- Rebuild for StartCom Linux 5.0.x

* Wed Dec 03 2008 Michal Hlavinka <mhlavink@redhat.com> 56-8
- ecryptfs_parse_packet_length() expects data type size_t, not uint32_t
- Resolves: #473272

* Tue Nov 18 2008 Karsten Hopp <karsten@redhat.com> 56-7
- disable gui

* Wed Oct 29 2008 Karsten Hopp <karsten@redhat.com> 56-6
- add fix for bugzilla #467234

* Wed Oct 29 2008 Karsten Hopp <karsten@redhat.com> 56-5
- fix verbosity=1 commandline parameter (#441822)

* Tue Sep 02 2008 Karsten Hopp <karsten@redhat.com> 56-4
- remove conflicting bytecompiled python files
- add some parameters to ecryptfs manpage

* Tue Aug 26 2008 Karsten Hopp <karsten@redhat.com> 56-3
- fix CFLAGS, remove static libs, -devel needs to requires pkgconfig (mnovak)
- fix openssl parameter checks (Eric Sandeen)
- Add mount helper gui (#445733, Jarod Wilson)
- Add missing BR: desktop-file-utils (Jarod Wilson)

* Fri Aug 14 2008 Karsten Hopp <karsten@redhat.com> 56-2
- fix warnings

* Fri Aug 14 2008 Karsten Hopp <karsten@redhat.com> 56-1
- update to version 56 to fix namespace problems for mount parameters

* Fri Aug 08 2008 Karsten Hopp <karsten@redhat.com> 53-1
- update to version 53
- drop verbosity from list of parameters passed to the mount command

* Sat Mar 08 2008 Karsten Hopp <karsten@redhat.com> 41-1
- update to 41

* Mon Feb 18 2008 Mike Halcrow <mhalcrow@us.ibm.com> 40-0
- Enable passwd_file option in openssl key module

* Wed Feb 13 2008 Mike Halcrow <mhalcrow@us.ibm.com> 39-0
- Fix include upstream

* Wed Feb 13 2008 Karsten Hopp <karsten@redhat.com> 38-1
- fix includes

* Mon Jan 14 2008 Karsten Hopp <karsten@redhat.com> 38-1
- update to version 38

* Fri Dec 21 2007 Jarod Wilson <jwilson@redhat.com> 37-1
- update to version 37

* Fri Dec 14 2007 Karsten Hopp <karsten@redhat.com> 32-2
- fix conflicts as our kernel has a ecryptfs backport

* Thu Dec 13 2007 Karsten Hopp <karsten@redhat.com> 32-1
- update to version 32

* Thu Nov 29 2007 Karsten Hopp <karsten@redhat.com> 30-2
- fix ia64 libdir
- build initial RHEL-5 version

* Thu Nov 29 2007 Karsten Hopp <karsten@redhat.com> 30-1
- build version 30

* Fri Oct 05 2007 Mike Halcrow <mhalcrow@us.ibm.com> - 30-0
- Bump to version 30. Several bugfixes. Key modules are overhauled
  with a more sane API.
* Wed Aug 29 2007 Fedora Release Engineering <rel-eng at fedoraproject dot org> - 18-1
- Rebuild for selinux ppc32 issue.

* Thu Jun 28 2007 Mike Halcrow <mhalcrow@us.ibm.com> - 18-0
- Bump to version 18 with an OpenSSL key module fix
* Thu Jun 21 2007 Kevin Fenzi <kevin@tummy.com> - 17-1
- Change kernel Requires to Conflicts
- Remove un-needed devel buildrequires
* Wed Jun 20 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 17-0
- Provide built-in fallback passphrase key module. Remove keyutils,
  openssl, and pam requirements (library dependencies take care of
  this). Include wrapped passphrase executables in file set.
* Fri Apr 20 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 15-1
- Change permission of pam_ecryptfs.so from 644 to 755.
* Thu Apr 19 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 15-0
- Fix mount option parse segfault. Fix pam_ecryptfs.so semaphore
  issue when logging in via ssh.
* Thu Mar 01 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 10-0
- Remove verbose syslog() calls; change key module build to allow
  OpenSSL module to be disabled from build; add AUTHORS, NEWS, and
  THANKS to docs; update Requires with variables instead of hardcoded
  name and version.
* Tue Feb 06 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 9-1
- Minor update in README, add dist tag to Release, add --disable-rpath
  to configure step, and remove keyutils-libs from Requires.
* Tue Jan 09 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 9-0
- Correct install directories for 64-bit; add support for xattr and
  encrypted_view mount options
* Tue Jan 02 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 8-0
- Introduce build support for openCryptoki key module.  Fix -dev build
  dependencies for devel package
* Mon Dec 11 2006 Mike Halcrow <mhalcrow@us.ibm.com>  - 7-0
- Initial package creation
